# Package

version       = "1.1.0"
author        = "Christine Dodrill"
description   = "a list of twtxt hacker feeds"
license       = "MIT"
srcDir        = "src"
bin           = @["twtxtlist", "worker"]

# Dependencies

requires "nim >= 0.13.0", "jester", "moustachu", "shorturl", "q"

mode = ScriptMode.Verbose

task db, "SQLite database prompt":
  exec "sqlite3 data/twtxt.db"

task godep, "build go deps":
  withDir "src/time":
    exec "go build -buildmode=c-shared -o gotime.so time.go"
    exec "cp gotime.so ../.."

task run, "Run app":
  exec "nimble build"
  exec "./twtxtlist"
